Merged revisions 115554 via svnmerge from
[asterisk/asterisk.git] / contrib / init.d / rc.debian.asterisk
1 #! /bin/sh
2 # $Id$
3 #
4 # Mon Jun 04 2007 IƱaki Baz Castillo <ibc@in.ilimit.es>
5 # - Eliminated SAFE_ASTERISK since it doesn't work as LSB script (it could require a independent "safe_asterisk" init script).
6 # - Load and use the standar "/lib/lsb/init-functions".
7 # - Addded "--oknodo" to "start-stop-daemon" for compatibility with LSB:
8 #   http://www.linux-foundation.org/spec/refspecs/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/iniscrptact.html
9 #
10 # Thu Nov 17 2005 Gregory Boehnlein <damin@nacs.net>
11 # - Reversed behavior of LD_ASSUME_KERNEL=2.4.1
12 # - Added detailed failure messages
13 #
14 # Sun Jul 18 2004 Gregory Boehnlein <damin@nacs.net>
15 # - Added test for safe_asterisk
16 # - Changed "stop gracefully" to "stop now"
17 # - Added support for -U and -G command line options
18 # - Modified "reload" to call asterisk -rx 'reload' 
19
20 PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
21 NAME=asterisk
22 DESC="Asterisk PBX"
23 # Full path to asterisk binary
24 DAEMON=/usr/sbin/asterisk
25 TRUE=/bin/true
26
27 # Uncomment this ONLY if you know what you are doing.
28 # export LD_ASSUME_KERNEL=2.4.1
29
30 # Uncomment the following and set them to the user/groups that you
31 # want to run Asterisk as. NOTE: this requires substantial work to
32 # be sure that Asterisk's environment has permission to write the
33 # files required  for  its  operation, including logs, its comm
34 # socket, the asterisk database, etc.
35 #AST_USER="asterisk"
36 #AST_GROUP="asterisk"
37
38 set -e
39
40 if ! [ -x $DAEMON ] ; then
41         echo "ERROR: $DAEMON not found"
42         exit 0
43 fi
44
45 if ! [ -d /etc/asterisk ] ; then
46         echo "ERROR: /etc/asterisk directory not found"
47         exit 0
48 fi
49
50 # Use the LSB standar functions for services management
51 . /lib/lsb/init-functions
52
53 case "$1" in
54   start)
55         # Check if Asterisk is already running.  If it is, then bug out, because
56         # starting up Asterisk when Asterisk is already running is very bad.
57         VERSION=`${DAEMON} -rx 'core show version' || ${TRUE}`
58         if [ "${VERSION:0:8}" = "Asterisk" ]; then # otherwise "Unable t"
59                 echo "Asterisk is already running.  $0 will exit now."
60                 exit 1
61         fi
62
63         log_begin_msg "Starting $DESC: $NAME"
64         if [ $AST_USER ] ; then
65                 ASTARGS="-U $AST_USER"
66         fi
67         if [ $AST_GROUP ] ; then
68                 ASTARGS="$ASTARGS -G $AST_GROUP"
69         fi
70         # "start-stop-daemon --oknodo" returns 0 even if Asterisk was already running (as LSB expects):
71         start-stop-daemon --start --oknodo --exec $DAEMON -- $ASTARGS
72         log_end_msg $?
73         ;;
74   stop)
75         log_begin_msg "Stopping $DESC: $NAME"
76         # "start-stop-daemon --oknodo" returns 0 even if Asterisk was already stopped (as LSB expects):
77         start-stop-daemon --stop --oknodo --exec $DAEMON
78         log_end_msg $?
79         ;;
80   reload)
81         echo "Reloading $DESC configuration files."
82         $DAEMON -rx 'reload' > /dev/null 2> /dev/null
83         ;;
84   restart|force-reload)
85         $0 stop
86         sleep 2  # It needs some time to really be stopped.
87         $0 start
88         # "restart|force-reload" starts Asterisk and returns 0 even if Asterisk was stopped (as LSB expects).
89         ;;
90   *)
91         N=/etc/init.d/$NAME
92         echo "Usage: $N {start|stop|restart|reload|force-reload}" >&2
93         exit 1
94         ;;
95 esac